/*  
  Copyright 1997-98 Michael Callahan
  Copyright 1999 Carnegie Mellon University
  This program is free software.  You may copy it according
  to the conditions of the GNU General Public License version 2.0
  or later; see the file COPYING in the source directory.
*/

typedef struct _CBUF {
	PVMMMUTEX		cb_mutex;
	PCHAR			cb_start;
	PCHAR			cb_end;
	PCHAR			cb_head;
	PCHAR			cb_tail;
} CBUF, *PCBUF;

PCBUF NewCBuf (int size);
void FreeCBuf (PCBUF buf);
int ResizeCBuf (PCBUF buf, int newsize);

int LenCBuf (PCBUF buf);
int AvailCBuf (PCBUF buf);
int EmptyCBuf (PCBUF buf);

void LockCBuf (PCBUF buf);
int TryLockCBuf (PCBUF buf);
void UnlockCBuf (PCBUF buf);

int PeekCBuf (PCBUF buf, PCHAR out, DWORD maxlen);
int GetCBuf (PCBUF buf, PCHAR out, DWORD maxlen);
void PopCBuf (PCBUF buf, DWORD len);
int PutCBuf (PCBUF buf, PCHAR in, DWORD len);


